Name:          jtb
Version:       1.3.2
Release:       1%{?dist}
Summary:       Java Tree Builder
License:       BSD
URL:           http://compilers.cs.ucla.edu/jtb/
Source0:       http://compilers.cs.ucla.edu/jtb/Files/jtb132.src.jar
Source1:       http://central.maven.org/maven2/edu/ucla/cs/compilers/%{name}/%{version}/%{name}-%{version}.pom

BuildRequires: java-devel
BuildRequires: javapackages-local

BuildArch:     noarch

%description
JTB is a syntax tree builder to be used with the
Java Compiler Compiler (JavaCC) parser generator.
It takes a plain JavaCC grammar file as input and
automatically generates the following: 

* A set of syntax tree classes based on the
  productions in the grammar, utilizing the
  Visitor design pattern.

* Two interfaces: Visitor and GJVisitor.
  Two depth-first visitors: DepthFirstVisitor and
  GJDepthFirst, whose default methods simply
  visit the children of the current node.

* A JavaCC grammar jtb.out.jj with the
  proper annotations to build the syntax tree
  during parsing.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -c

rm -r META-INF
cp -p EDU/purdue/jtb/LICENSE .
mkdir docs

%mvn_file edu.ucla.cs.compilers:%{name} %{name}

%build

# Generated with javacc 3.x
#rm EDU/purdue/jtb/parser/JavaCharStream.java
#rm EDU/purdue/jtb/parser/JTBParser.java
#rm EDU/purdue/jtb/parser/JTBParserConstants.java
#rm EDU/purdue/jtb/parser/JTBParserTokenManager.java
#rm EDU/purdue/jtb/parser/ParseException.java
#rm EDU/purdue/jtb/parser/Token.java
#rm EDU/purdue/jtb/parser/TokenMgrError.java

#(
# cd EDU/purdue/jtb/parser
# javacc.sh ../jtbgram.jj
#)
# Build fails
#./EDU/purdue/jtb/JTB.java:98: error: incompatible types: void cannot be converted to Node
#         root = parser.JavaCCInput();

%javac $(find -name "*.java")
%jar cvfe %{name}.jar EDU.purdue.jtb.JTB $(find -name "*.class")
%javadoc -encoding UTF-8 -Xdoclint:none -d docs $(find -name "*.java")

%install
%mvn_artifact %{SOURCE1} %{name}.jar
%mvn_install -J docs

%files -f .mfiles
%license LICENSE

%files javadoc -f .mfiles-javadoc
%license LICENSE

%changelog
* Sun Aug 28 2016 gil cattaneo <puntogil@libero.it> 1.3.2-1
- initial rpm

